//! @file usb_descriptors.c,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief USBҰ
//!
//! ̧ق͋Lqq\ʂĉpʂɎʂUSBҰ܂݂܂B
//!
//! @version 1.3 at90usb128-demo-hidgen-1_0_0 $Id: usb_descriptors.c,v 1.3 2006/03/17 13:06:34 rletendu Exp $
//!
//! @todo
//! @bug

//_____ ݸٰ _______________________________________________________________

#include "config.h"
#include "conf_usb.h"

#include "lib_mcu\usb\usb_drv.h"
#include "usb_descriptors.h"
#include "modules\usb\device_chap9\usb_standard_request.h"
#include "usb_specific_request.h"

//_____ ϸ ___________________________________________________________________

//_____ ` __________________________________________________________________

// usb_user_device_descriptor
code S_usb_device_descriptor usb_dev_desc =
{
	sizeof(usb_dev_desc),
	DEVICE_DESCRIPTOR,
	Usb_write_word_enum_struc(USB_SPECIFICATION),
	DEVICE_CLASS,
	DEVICE_SUB_CLASS,
	DEVICE_PROTOCOL,
	EP_CONTROL_LENGTH,
	Usb_write_word_enum_struc(VENDOR_ID),
	Usb_write_word_enum_struc(PRODUCT_ID),
	Usb_write_word_enum_struc(RELEASE_NUMBER),
	MAN_INDEX,
	PROD_INDEX,
	SN_INDEX,
	NB_CONFIGURATION
};

// usb_user_configuration_descriptor FS
code S_usb_user_configuration_descriptor usb_conf_desc =
{
	{
		sizeof(S_usb_configuration_descriptor),
		CONFIGURATION_DESCRIPTOR,
		Usb_write_word_enum_struc(sizeof(S_usb_configuration_descriptor)+sizeof(S_usb_interface_descriptor)\
		+sizeof(S_usb_hid_descriptor)+sizeof(S_usb_endpoint_descriptor)+sizeof(S_usb_endpoint_descriptor)),
		NB_INTERFACE,
		CONF_NB,
		CONF_INDEX,
		CONF_ATTRIBUTES,
		MAX_POWER
	},
	{
		sizeof(S_usb_interface_descriptor),
		INTERFACE_DESCRIPTOR,
		INTERFACE_NB,
		ALTERNATE,
		NB_ENDPOINT,
		INTERFACE_CLASS,
		INTERFACE_SUB_CLASS,
		INTERFACE_PROTOCOL,
		INTERFACE_INDEX
	},
	{ 9, HID, 0x0111, 8, 1, REPORT, SIZE_OF_REPORT },
	{
		sizeof(S_usb_endpoint_descriptor),
		ENDPOINT_DESCRIPTOR,
		ENDPOINT_NB_1,
		EP_ATTRIBUTES_1,
		Usb_write_word_enum_struc(EP_SIZE_1),
		EP_INTERVAL_1
	},
	{
		sizeof(S_usb_endpoint_descriptor),
		ENDPOINT_DESCRIPTOR,
		ENDPOINT_NB_2,
		EP_ATTRIBUTES_2,
		Usb_write_word_enum_struc(EP_SIZE_2),
		EP_INTERVAL_2
	}
};

// usb_user_manufacturer_string_descriptor
code S_usb_manufacturer_string_descriptor usb_user_manufacturer_string_descriptor =
{
	sizeof(usb_user_manufacturer_string_descriptor),
	STRING_DESCRIPTOR,
	USB_MANUFACTURER_NAME
};

// usb_user_product_string_descriptor
code S_usb_product_string_descriptor usb_user_product_string_descriptor =
{
	sizeof(usb_user_product_string_descriptor),
	STRING_DESCRIPTOR,
	USB_PRODUCT_NAME
};

// usb_user_serial_number
code S_usb_serial_number usb_user_serial_number =
{
	sizeof(usb_user_serial_number),
	STRING_DESCRIPTOR,
	USB_SERIAL_NUMBER
};

// usb_user_language_id
code S_usb_language_id usb_user_language_id =
{
	sizeof(usb_user_language_id),
	STRING_DESCRIPTOR,
	Usb_write_word_enum_struc(LANGUAGE_ID)
};

code S_usb_hid_report_descriptor usb_hid_report_descriptor =
{
	0x06, 0xFF, 0xFF,			// 04|2 gp߰ (Ғ`?)
	0x09, 0x01,					// 08|1 gp      (Ғ`)
	0xA1, 0x01,					// A0|1 W      (p)
	// IN
	0x09, 0x02,					// 08|1 gp     (Ғ`)
	0x09, 0x03,					// 08|1 gp     (Ғ`)
	0x15, 0x00,					// 14|1 _ŏ (t޲Ăɑ΂0?)
	0x26 ,0xFF,0x00,			// 24|1 _ő (t޲Ăɑ΂255?)
	0x75, 0x08,					// 74|1 񍐑傫(8)=ޯĂł̗̈e=1޲
	0x95, LENGTH_OF_REPORT_IN,	// 94|1 񍐐(傫)=Oڂ̌JԂ
	0x81, 0x02,					// 80|1 IN   (ް,ϐ,)
	// OUT
	0x09, 0x04,					// 08|1 gp     (Ғ`)
	0x09, 0x05,					// 08|1 gp     (Ғ`)
	0x15, 0x00,					// 14|1 _ŏ (t޲Ăɑ΂0?)
	0x26, 0xFF,0x00,			// 24|1 _ő (t޲Ăɑ΂255?)
	0x75, 0x08,					// 74|1 񍐑傫(8)=ޯĂł̗̈e=1޲
	0x95, LENGTH_OF_REPORT_OUT,	// 94|1 񍐐(傫)=Oڂ̌JԂ
	0x91, 0x02,					// 90|1 OUT  (ް,ϐ,)
	// @\
	0x09, 0x06,					// 08|1 gp     (Ғ`)
	0x09, 0x07,					// 08|1 gp     (Ғ`)
	0x15, 0x00,					// 14|1 _ŏ (t޲Ăɑ΂0?)
	0x26, 0xFF,0x00,			// 24|1 _ő (t޲Ăɑ΂255?)
	0x75, 0x08,					// 74|1 񍐑傫(8)=ޯĂł̗̈e=1޲
	0x95, 0x04,					// 94|1 񍐐
	0xB1, 0x02,					// B0|1 @\
	0xC0						// C0|0 WI
};
